2003-04-15  Mark McLoughlin  <mark {at} skynet.ie>

        * libegg/tray/eggstatusicon.[ch]: re-do to (partly)
        implement the latest API proposed on gtk-devel-list.
        Kinda crufty, though.

        * libegg/tray/teststatusicon.c: update.

        * libegg/util/eggmarshalers.list: add some marshallers.
1 /* eggstatusicon.h:
 
2  *
 
3  * Copyright (C) 2003 Sun Microsystems, Inc.
 
4  *
 
5  * This library is free software; you can redistribute it and/or
 
6  * modify it under the terms of the GNU Lesser General Public
 
7  * License as published by the Free Software Foundation; either
 
8  * version 2 of the License, or (at your option) any later version.
 
9  *
 
10  * This library is distributed in the hope that it will be useful,
 
11  * but WITHOUT ANY WARRANTY; without even the implied warranty of
 
12  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 
13  * Lesser General Public License for more details.
 
14  *
 
15  * You should have received a copy of the GNU Lesser General Public
 
16  * License along with this library; if not, write to the
 
17  * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 
18  * Boston, MA 02111-1307, USA.
 
19  *
 
20  * Authors:
 
21  *      Mark McLoughlin <mark@skynet.ie>
 
22  */
 
23  
24 #ifndef __EGG_STATUS_ICON_H__
 
25 #define __EGG_STATUS_ICON_H__
 
26  
27 #include "eggtrayicon.h"
 
28 #include <gtk/gtkimage.h>
 
29  
30 G_BEGIN_DECLS
 
31  
32 #define EGG_TYPE_STATUS_ICON         (egg_status_icon_get_type ())
 
33 #define EGG_STATUS_ICON(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), EGG_TYPE_STATUS_ICON, EggStatusIcon))
 
34 #define EGG_STATUS_ICON_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST ((k), EGG_TYPE_STATUS_ICON, EggStatusIconClass))
 
35 #define EGG_IS_STATUS_ICON(o)        (G_TYPE_CHECK_INSTANCE_TYPE ((o), EGG_TYPE_STATUS_ICON))
 
36 #define EGG_IS_STATUS_ICON_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), EGG_TYPE_STATUS_ICON))
 
37 #define EGG_STATUS_ICON_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), EGG_TYPE_STATUS_ICON, EggStatusIconClass))
 
38 	
 
39 typedef struct _EggStatusIcon	     EggStatusIcon;
 
40 typedef struct _EggStatusIconClass   EggStatusIconClass;
 
41 typedef struct _EggStatusIconPrivate EggStatusIconPrivate;
 
42  
43 struct _EggStatusIcon
 
44 {
 
45   GObject               parent_instance;
 
46  
47   EggStatusIconPrivate *priv;
 
48 };
 
49  
50 struct _EggStatusIconClass
 
51 {
 
52   GObjectClass parent_class;
 
53  
54   void     (* activate)     (EggStatusIcon *status_icon);
 
55   void     (* popup_menu)   (EggStatusIcon *status_icon,
 
56 			     guint          buttton,
 
57 			     guint32        activate_time);
 
58   gboolean (* size_changed) (EggStatusIcon *status_icon,
 
59 			     gint           size);
 
60 };
 
61  
62 GType                 egg_status_icon_get_type           (void);
 
63  
64 EggStatusIcon        *egg_status_icon_new                (void);
 
65 EggStatusIcon        *egg_status_icon_new_from_pixbuf    (GdkPixbuf          *pixbuf);
 
66 EggStatusIcon        *egg_status_icon_new_from_file      (const gchar        *filename);
 
67 EggStatusIcon        *egg_status_icon_new_from_stock     (const gchar        *stock_id);
 
68 EggStatusIcon        *egg_status_icon_new_from_animation (GdkPixbufAnimation *animation);
 
69  
70 void                  egg_status_icon_set_from_pixbuf    (EggStatusIcon      *status_icon,
 
71 							  GdkPixbuf          *pixbuf);
 
72 void                  egg_status_icon_set_from_file      (EggStatusIcon      *status_icon,
 
73 							  const gchar        *filename);
 
74 void                  egg_status_icon_set_from_stock     (EggStatusIcon      *status_icon,
 
75 							  const gchar        *stock_id);
 
76 void                  egg_status_icon_set_from_animation (EggStatusIcon      *status_icon,
 
77 							  GdkPixbufAnimation *animation);
 
78  
79 GtkImageType          egg_status_icon_get_image_type     (EggStatusIcon      *status_icon);
 
80  
81 GdkPixbuf            *egg_status_icon_get_pixbuf         (EggStatusIcon      *status_icon);
 
82 G_CONST_RETURN gchar *egg_status_icon_get_stock          (EggStatusIcon      *status_icon);
 
83 GdkPixbufAnimation   *egg_status_icon_get_animation      (EggStatusIcon      *status_icon);
 
84  
85 gint                  egg_status_icon_get_size           (EggStatusIcon      *status_icon);
 
86  
87 void                  egg_status_icon_set_tooltip        (EggStatusIcon      *status_icon,
 
88 							  const gchar        *tooltip_text,
 
89 							  const gchar        *tooltip_private);
 
90  
91 void                  egg_status_icon_set_balloon_text   (EggStatusIcon      *status_icon,
 
92 							  const gchar        *text);
 
93 G_CONST_RETURN gchar *egg_status_icon_get_balloon_text   (EggStatusIcon      *status_icon);
 
94  
95 void                  egg_status_icon_set_is_blinking    (EggStatusIcon      *status_icon,
 
96 							  gboolean            enable_blinking);
 
97 gboolean              egg_status_icon_get_is_blinking    (EggStatusIcon      *status_icon);
 
98  
99 G_END_DECLS
 
100  
101 #endif /* __EGG_STATUS_ICON_H__ */
 
