2002-05-16  Havoc Pennington  <hp {at} redhat.com>

	* libegg/tray/*: Port the tray back to GTK 2.0 so people can test
	it out.
1 #include <gtk/gtk.h>
 
2 #include "eggtrayicon.h"
 
3  
4 static void
 
5 first_button_pressed (GtkWidget *button, EggTrayIcon *icon)
 
6 {
 
7   guint id;
 
8   
 
9   g_print ("woohoo, first button is pressed!\n");
 
10  
11   id = egg_tray_icon_send_message (icon, 0, "This is a message from the first tray icon", -1);
 
12   g_print ("Sent message, id is: %d\n", id);
 
13 }
 
14  
15 static void
 
16 second_button_pressed (GtkWidget *button, EggTrayIcon *icon)
 
17 {
 
18   g_print ("woohoo, second button is pressed!\n");
 
19  
20   egg_tray_icon_cancel_message (icon, 12345);
 
21 }
 
22  
23 gint
 
24 main (gint argc, gchar **argv)
 
25 {
 
26   GtkWidget *button;
 
27   EggTrayIcon *tray_icon;
 
28  
29   gtk_init (&argc, &argv);
 
30  
31   tray_icon = egg_tray_icon_new ("Our cool tray icon");
 
32   button = gtk_button_new_with_label ("This is a cool\ntray icon");
 
33   g_signal_connect (button, "clicked",
 
34 		    G_CALLBACK (first_button_pressed), tray_icon);
 
35   gtk_container_add (GTK_CONTAINER (tray_icon), button);
 
36   gtk_widget_show_all (GTK_WIDGET (tray_icon));
 
37  
38   tray_icon = egg_tray_icon_new ("Our other cool tray icon");
 
39   button = gtk_button_new_with_label ("This is a another\ncool tray icon");
 
40   g_signal_connect (button, "clicked",  
41 		    G_CALLBACK (second_button_pressed), tray_icon);
 
42  
43   gtk_container_add (GTK_CONTAINER (tray_icon), button);
 
44   gtk_widget_show_all (GTK_WIDGET (tray_icon));
 
45  
46   gtk_main ();
 
47   
 
48   return 0;
 
49 }